#include <Blackfin_definitions.h>
#include <functions.h>

extern int DummyBuffer;
extern int SPICount;
extern int TransferStatus;
extern int InterruptCause;
extern int TimerInterruptCause;
extern int ClockDone;
extern int PPIDone;
extern int ReadyForInput;
extern volatile int ZeroRxd;
int CardDetected = 0;
int Debounce;
int tempvar;
int PPIDMACount = 0;


EX_INTERRUPT_HANDLER (MMCIsr)
{
    PPIDMACount++;
    switch(InterruptCause)
    {
    	case 1: *pDMA0_IRQ_STATUS |= 0x0001;
    			PPIDone = 0;  
    			break;
    	case 2: *pDMA0_IRQ_STATUS |= 0x0001;
    			ssync();
    			//*pDMA0_CONFIG = 0x0;  
    			*pTIMER_DISABLE = TIMDIS7 | TIMDIS6;
		    	while(*pTIMER_STATUS & TRUN7);
		    	while(*pTIMER_STATUS & TRUN6);
		    	PPIDone = 0; 
    			break;
    			
    	case 3: *pDMA0_IRQ_STATUS |= 0x0001;
    			ssync();
    			DisablePPIReceive();   
    			*pTIMER_DISABLE = TIMDIS7 | TIMDIS6 | TIMDIS4;
		    	while(*pTIMER_STATUS & (TRUN7|TRUN6|TRUN4));
    			PPIDone = 0; 
    			break;
    			
    	case 4: *pDMA0_IRQ_STATUS |= 0x0001;
    			ssync();
    			DisablePPIReceive();   
    			*pTIMER_DISABLE = TIMDIS7 | TIMDIS6;
		    	while(*pTIMER_STATUS & (TRUN7|TRUN6));
    			PPIDone = 0; 
    			break;
    			
    	case 5: *pDMA0_IRQ_STATUS |= 0x0001;
    			ssync();
    			
    			
    	default:break;
    }
}

EX_INTERRUPT_HANDLER (PFIsr)
{
	*pPORTGIO_CLEAR = PG8;
	ZeroRxd = 0;
	ssync();
}

EX_INTERRUPT_HANDLER (CDIsr)
{
	*pPORTFIO_CLEAR = PF12;
	int tempvar;
    Debounce++;
    
    if(Debounce>2000000)
    {   *pPORTFIO_INEN &= ~PF12;
    	*pSIC_IMASK &= ~IRQ_PFB_PORTF;
    	CardDetected = 1;
    	*pPORTFIO_CLEAR = PF13;
    }
    tempvar = *pPORTFIO_CLEAR;

}

